/*
 * Description: This application tests the use of conditional variables to sync two threads.
 * The first thread is running in the host CPU and the 2nd on is running in the GPU with OpenMP target.
 * 
 * The WATERS19 app4mc example shows that, in case of GPU offloading (OpenMP-based offloading), 
 * there must have two tasks. The first task, running in the Host side, does data preparation, 
 * input/output data copies. This first task is periodic.
 * The second task, running in the GPU side, does the computation itself. This task is blocked by the 1st one.
 * So, this example tests the sync mechanism used between these two tasks.
 * 
 * The 1st task uses InterProcessStimulus to call the 2nd task. Then the 1st is suspended until 
 * a signal (an OSEvent) comes from the 2nd task, indicating that the processing is done. 
 * 
 * This test will check whether two CPP conditional_variables can implement the same sync behavior.
 *  
 * This link https://tatourian.blog/2013/03/26/producer-consumer-inter-thread-communication-using-condition-variables-in-c/
 * helped to build this example.
 *
 * Author: 
 *  Alexandre Amory (February 2021), ReTiS Lab, Scuola Sant'Anna, Pisa, Italy.
 * 
 * Compilation: 
 *  $> clang++ -fopenmp -fopenmp-targets=nvptx64-nvidia-cuda  host_gpu_sync_openmp.cpp -o host_gpu_sync_openmp
 *  
 *  ps.: If optimization is enables, the internal loop for wasting time will disapear
 *  
 * Usage Example (in the Xavier board): 
 *  $> sudo su
 *  $> nvprof ./host_gpu_sync_openmp
# nvprof ./host_gpu_sync_openmp
==3540== NVPROF is profiling process 3540, command: ./host_gpu_sync_openmp
==3540== Warning: Unified Memory Profiling is not supported on the underlying platform. System requirements for unified memory can be found at: http://docs.nvidia.com/cuda/cuda-c-programming-guide/index.html#um-requirements
The 'HOST' (The GPU thread (0) is blocked 
0) is preparing the input data to the GPU ...
Data is done! Firing the GPU ...
HOST pre-processing time = 1328[µs]
The GPU thread (0) is unblocked 
isHost=0
GPU processing time = 3698458[µs]
The GPU thread (0) finished 
The GPU thread (1) is blocked 
The HOST thread (0) is unblocked 
The 'HOST' (0) is fixing the output data generated by the GPU ...
The HOST thread (0) is finished 


HOST pos-processing time = 2708[µs]
The 'HOST' (1) is preparing the input data to the GPU ...
Data is done! Firing the GPU ...
HOST pre-processing time = 0[µs]
The GPU thread (1) is unblocked 
isHost=0
GPU processing time = 3109391[µs]
The GPU thread (1) finished 
The GPU thread (2) is blocked 
The HOST thread (1) is unblocked 
The 'HOST' (1) is fixing the output data generated by the GPU ...
The HOST thread (1) is finished 


HOST pos-processing time = 0[µs]
The 'HOST' (2) is preparing the input data to the GPU ...
Data is done! Firing the GPU ...
HOST pre-processing time = 0[µs]
The GPU thread (2) is unblocked 
isHost=0
GPU processing time = 3109285[µs]
The GPU thread (2) finished 
The HOST thread (2) is unblocked 
The 'HOST' (2) is fixing the output data generated by the GPU ...
The HOST thread (2) is finished 


HOST pos-processing time = 0[µs]
the threads were joined...
==3540== Profiling application: ./host_gpu_sync_openmp
==3540== Profiling result:
            Type  Time(%)      Time     Calls       Avg       Min       Max  Name
 GPU activities:  100.00%  9.63725s         3  3.21242s  3.10849s  3.42028s  __omp_offloading_b301_164a41__Z3gpuv_l81
                    0.00%  7.1050us         4  1.7760us  1.1520us  3.5850us  [CUDA memcpy DtoH]
                    0.00%  1.2480us         1  1.2480us  1.2480us  1.2480us  [CUDA memcpy HtoD]
      API calls:   96.64%  9.63747s         3  3.21249s  3.10853s  3.42040s  cuMemcpyDtoHAsync
                    2.16%  215.66ms         1  215.66ms  215.66ms  215.66ms  cuDevicePrimaryCtxRetain
                    0.60%  60.227ms         1  60.227ms  60.227ms  60.227ms  cuModuleLoadDataEx
                    0.40%  39.399ms         1  39.399ms  39.399ms  39.399ms  cuDevicePrimaryCtxRelease
                    0.16%  16.167ms         1  16.167ms  16.167ms  16.167ms  cuModuleUnload
                    0.01%  1.1723ms         3  390.77us  287.25us  552.95us  cuMemAlloc
                    0.01%  798.98us         3  266.33us  254.73us  285.07us  cuMemFree
                    0.01%  563.16us        32  17.598us  1.8240us  289.04us  cuStreamCreate
                    0.00%  279.28us         3  93.092us  63.491us  124.13us  cuLaunchKernel
                    0.00%  255.21us        32  7.9750us  3.6160us  42.370us  cuStreamDestroy
                    0.00%  102.92us        17  6.0530us     992ns  41.410us  cuCtxSetCurrent
                    0.00%  99.844us         1  99.844us  99.844us  99.844us  cuMemcpyDtoH
                    0.00%  53.058us         1  53.058us  53.058us  53.058us  cuMemcpyHtoD
                    0.00%  42.435us         3  14.145us  11.361us  19.009us  cuStreamSynchronize
                    0.00%  12.545us         3  4.1810us  2.5920us  5.2800us  cuFuncGetAttribute
                    0.00%  8.4170us         2  4.2080us  2.5610us  5.8560us  cuModuleGetGlobal
                    0.00%  8.4160us         3  2.8050us  1.2160us  4.7040us  cuDeviceGetCount
                    0.00%  7.2320us         2  3.6160us  2.7200us  4.5120us  cuDeviceGet
                    0.00%  6.2080us         6  1.0340us     736ns  1.5360us  cuDeviceGetAttribute
                    0.00%  4.2880us         1  4.2880us  4.2880us  4.2880us  cuModuleGetFunction
                    0.00%  2.4960us         1  2.4960us  2.4960us  2.4960us  cuDevicePrimaryCtxGetState
                    0.00%  1.8880us         1  1.8880us  1.8880us  1.8880us  cuDevicePrimaryCtxSetFlags
                    0.00%  1.2800us         1  1.2800us  1.2800us  1.2800us  cuCtxGetDevice
 */

// condition_variable example
#include <iostream>           // std::cout
#include <thread>             // std::thread
#include <mutex>              // std::mutex, std::unique_lock
#include <condition_variable> // std::condition_variable
#include <omp.h>
#include <chrono>

struct offloading_sync
{
  std::mutex mtx;
  std::condition_variable cvar;
  bool ready;

  offloading_sync(){
    this->ready = false;
  }
};

struct offloading_sync sync_start;
struct offloading_sync sync_end;

#define REPEATS 3

// this is imitating a GPU task, expecting to be unblocked by the HOST to
// do some super important computation
void gpu () {
  int iter=0;
  std::chrono::steady_clock::time_point begin;
  std::chrono::steady_clock::time_point end;

  while(iter < REPEATS){
    {
      int isHost = 0;
      std::cout << "The GPU thread ("<< iter << ") is blocked \n";
      std::unique_lock<std::mutex> lck(sync_start.mtx);
      while (!sync_start.ready){
        sync_start.cvar.wait(lck);
      }
      std::cout << "The GPU thread ("<< iter << ") is unblocked \n";
      begin = std::chrono::steady_clock::now();
      // the 'GPU' is computing ...
      #pragma omp target map(from: isHost)
      { isHost = omp_is_initial_device(); 
        for (int i=0; i < 10000000; i++);
      }
      end = std::chrono::steady_clock::now();
      // when it prints 0, then offloading is working
      printf("isHost=%d\n", isHost);
      std::cout << "GPU processing time = " << std::chrono::duration_cast<std::chrono::microseconds>(end - begin).count() << "[µs]" << std::endl;
      sync_start.ready = false;
    }

    // the GPU is done. Now, we are unblocking the HOST
    std::unique_lock<std::mutex> lck2(sync_end.mtx);
    sync_end.ready = true;
    sync_end.cvar.notify_all();    
    std::cout << "The GPU thread ("<< iter << ") finished \n";
    iter++;
  }
}

// this is imitating the HOST task that does some data adaptation and fires the GPU
void host() {
  int iter=0;
  std::chrono::steady_clock::time_point begin;
  std::chrono::steady_clock::time_point end;

  // stays firing the GPU forever
  while(iter < REPEATS){
    {
      std::unique_lock<std::mutex> lck(sync_start.mtx);
      std::cout << "The 'HOST' ("<< iter << ") is preparing the input data to the GPU ...\n";
      begin = std::chrono::steady_clock::now();
      for (int i; i < 1000000; i++);
      end = std::chrono::steady_clock::now();
      sync_start.ready = true;
      std::cout << "Data is done! Firing the GPU ...\n";
      std::cout << "HOST pre-processing time = " << std::chrono::duration_cast<std::chrono::microseconds>(end - begin).count() << "[µs]" << std::endl;
      sync_start.cvar.notify_all();
    }

    // now master is blocked, waiting the GPU to unlock it
    std::unique_lock<std::mutex> lck2(sync_end.mtx);
    while (!sync_end.ready){
      sync_end.cvar.wait(lck2);
    }
    sync_end.ready = false;
    std::cout << "The HOST thread ("<< iter << ") is unblocked \n";
    std::cout << "The 'HOST' ("<< iter << ") is fixing the output data generated by the GPU ...\n";
    begin = std::chrono::steady_clock::now();
    for (int i; i < 1000000; i++);
    end = std::chrono::steady_clock::now();
    std::cout << "HOST pos-processing time = " << std::chrono::duration_cast<std::chrono::microseconds>(end - begin).count() << "[µs]" << std::endl;
    std::cout << "The HOST thread ("<< iter << ") is finished \n\n\n";
    iter++;
  }
  // required to unblock the GPU for the last time
  std::unique_lock<std::mutex> lck(sync_start.mtx);
  sync_start.ready = true;
  sync_start.cvar.notify_all();
  
}

int main ()
{
  std::thread host_thread;
  std::thread gpu_thread;

  host_thread = std::thread(host);
  gpu_thread = std::thread(gpu);

  host_thread.join();
  gpu_thread.join();
  std::cout << "the threads were joined...\n";

  return 0;
}
